  ; This flag toggles the bochs-support. 0=Bochs off, 1=bochs on
USEBOCHS	EQU	0
  ; Greencolor is the color of the gree terminals. It's different on BOCHS
GREENCOLOR	EQU	(0ABH-8*16*USEBOCHS)

;
;Used to display the current viewport of the current terminal
;
SCROLL_TERM:
  PUSHAD
  PUSH ES
   ;-----------[ Move terminal memory to screen ]-------------
   MOV DX, 256-44
   MOV AX, [TERM_SCROLLPOS]
   SUB DX, AX
   MOV AX, 80*2
   MUL DX
   SHL EDX, 16
   MOV DX, AX
   MOV ESI, EDX

   ADD ESI, [TERM_MEMADDR]
   MOV EDI, 0B8000H	; Offset of the screen
   MOV ECX, 80*44*2/4	; need to move 80*44*2 *8 bit or 80*44*2/4 *32 bit

   PUSH DS
    MOV AX, GS
    MOV DS, AX
    MOV ES, AX
     CLD
     REP MOVSD
   POP DS

   ;-----------[ Print the new cursor if visible ]--------------
   MOV AX, [TERM_Y]
   ADD AX, 44
   SUB AX, [TERM_LINES]
   ADD AX, [TERM_SCROLLPOS]
   CMP AX, 44
   JA CURSOROUTOFSCREEN

   MOV DX, 160
   MUL DX
   SHL EDX, 16
   MOV DX, AX
   MOV AX, [TERM_X]
   MOVZX EAX, AX
   SHL EAX, 1
   ADD EDX, EAX
   MOV ESI, EDX
   ADD ESI, 0B8000H

   MOV AH, 009H
   MOV AL, 219             ; CURSORCHAR!
   MOV [GS:ESI], AL
   MOV [GS:ESI+1], AH
   MOV [TERM_CURSORADDR], ESI
CURSOROUTOFSCREEN:

  CALL CHECK4MAC

  POP ES
  POPAD
RET

;
; Changes the current Terminal to the one specified in EAX
;
SWITCH_ADDR1 DD 0
SWITCH_ADDR2 DD 0
SWITCH_NEW   DD 0

SWITCHTERMINAL:

   MOV [SWITCH_NEW], EAX
   CMP EAX, [CURRENTTERMINAL]
   JE near SWITCHTERMINALDONE

   MOV EAX, [TERM_MEMADDR]
   MOV [SWITCH_ADDR1], EAX

   MOV EAX, [SWITCH_NEW]
   CALL SETTERMINAL_W
   MOV AL, 1
   MOV [TERM_ACTIVE], AL

   MOV EAX, [TERM_MEMADDR]
   MOV [SWITCH_ADDR2], EAX

   ;-----------[ Display the name of the new terminal ]-----------
   MOV ESI, [SWITCH_NEW]
   SHL ESI, 6
   ADD ESI,  TERMINALS
   ADD ESI, 32
   MOV EDI, 0B8000H
   ADD EDI, 50*(80*2)
   ADD EDI, 5*(80*2)
   ADD EDI, 4
   MOV AH, 0F0H
   MOV ECX, 16
   WRITETERMNAMELOOP:
     MOV AL, [DS:ESI]
     MOV [GS:EDI+1], AH
     MOV [GS:EDI], AL
     INC ESI
     INC EDI
     INC EDI
   LOOP WRITETERMNAMELOOP

   ;------------[ Let the new terminal 'fall' into the screen ]-----------
   MOV AL, USEBOCHS ;BOCHS produces ugly results if the fall-loop is used, so we skip it...
   CMP AL, 0
   JNE near SKIPFALLLOOP

   MOV EDI, [SWITCH_ADDR2]
   ADD EDI, 80*2*(256-44)
   MOV ESI, 0B8000H
   ADD ESI, 80*2*(50+5)
   ADD ESI, 80*2
   MOV ECX, 80*44*2
  SWLOOP1:
    MOV AL, [GS:EDI]
    MOV [GS:ESI], AL
    INC ESI
    INC EDI
  LOOP SWLOOP1

  MOV ECX, 400
  XOR EDX, EDX
  MOV DX, 8*6
  DEC DX
  SHL EDX, 16
  MOV EBX, 010000H
  SWFALLLOOP:
    PUSH ECX
      MOV ECX, EDX
      SHR ECX, 16
      CALL SET_VGA_SPLIT
      ADD EDX, EBX
      ADD EBX, 77777
   POP ECX

  CMP EDX, 400*65536
  JB SWFALLLOOP
    MOV EDI, [SWITCH_ADDR2]
    ADD EDI, 80*2*(256-44)
    MOV ESI, 0B8000H
    MOV ECX, 80*44*2
  SWLOOP2:
     MOV AL, [GS:EDI]
     MOV [GS:ESI], AL
     INC ESI
     INC EDI
  LOOP SWLOOP2
  MOV CX, 8 * 6
  DEC CX
  CALL SET_VGA_SPLIT

SKIPFALLLOOP:

  ;----------------[ Display the new terminal ]-------------
  XOR AX, AX
  MOV [TERM_SCROLLPOS], AX
  CALL SCROLL_TERM


SWITCHTERMINALDONE:
RET




;
; Print a #13-character (linefeed) by scrolling both screen and terminal
;
NEWOUTCHAR_CR:
  XOR AX, AX
  MOV [TERM_X], AX
  MOV AX, [TERM_Y]
  INC AX
  CMP AX, [TERM_LINES]
  JB near NOLINEFEED

    ;------------[ Scroll the Terminal ]------------
    MOV EDI, [TERM_MEMADDR]
    MOV ESI, EDI
    MOV EAX, 80*2
    ADD ESI, EAX
    MOV ECX, [TERM_MEMSIZE]
    SUB ECX, EAX
    SHR ECX, 2

     PUSH ES
      PUSH DS
      MOV AX, GS
      MOV DS, AX
      MOV ES, AX
      CLD
       REP MOVSD
      POP DS

      ;------------[ Clear the last line of the terminal ]---------------
      MOV AH, GREENCOLOR
      CMP dword [CURRENTTERMINAL], 0
      JNE GREENLINEFEED
        MOV AH, 0FH
      GREENLINEFEED:
      MOV AL, ' '
      MOV EDI, [TERM_MEMADDR]
      ADD EDI, [TERM_MEMSIZE]
      SUB EDI, 80*2
      MOV ECX, 80
       REP STOSW          ;ES=GS=Target
     POP ES

    MOV AL, [TERM_ACTIVE]
    CMP AL, 0
    JE near DONTFEEDMONITOR

      ;----------[ Scroll the Screen ]--------------
      ; (TO DO: Probably copy the terminal-memory to the screen, since videomemory-reads are very slow)
      MOV EDI, 0B8000H
      MOV ESI, EDI
      MOV EAX, 80*2
      ADD ESI, EAX
      MOV ECX, (80*2)*44
      SUB ECX, EAX
      SHR ECX, 2

      PUSH ES
       PUSH DS
       MOV AX, GS
       MOV DS, AX
       MOV ES, AX
       CLD
        REP MOVSD
       POP DS
 
       ;----------[ Clear the last line of the screen ]------------
       MOV EDI, 0B8000H
       ADD EDI, (80*2)*43
       MOV ECX, 80
       MOV AH, GREENCOLOR
       CMP dword [CURRENTTERMINAL], 0
       JNE GREENLINEFEED2
         MOV AH, 0FH
       GREENLINEFEED2:
       MOV AL, ' '
        REP STOSW
      POP ES

     ;-------- [ CREATE NEW CURSOR... ] --------
     MOV AX, [TERM_Y]

     ADD AX, 44
     SUB AX, [TERM_LINES]

     MOV DX, 160
     MUL DX
     SHL EDX, 16
     MOV DX, AX
     MOV AX, [TERM_X]
     MOVZX EAX, AX
     SHL EAX, 1
     ADD EDX, EAX
     MOV ESI, EDX
     ADD ESI, 0B8000H

     MOV AH, 009H
     MOV AL, 219             ; CURSORCHAR!
     MOV [GS:ESI], AL
     MOV [GS:ESI+1], AH
     MOV [TERM_CURSORADDR], ESI

    CALL CHECK4MAC
   DONTFEEDMONITOR:
     JMP LINEFEEDDONE
NOLINEFEED:
  MOV [TERM_Y], AX
LINEFEEDDONE:
RET

;
; Print a backspace character (delete the last character on the screen)
;
NEWOUTCHAR_BS:
     MOV AX, [TERM_X]
     DEC AX
     MOV [TERM_X], AX
     MOV AX, [TERM_Y]
     ADD AX, 44
     SUB AX, [TERM_LINES]

     MOV DX, 160
     MUL DX
     SHL EDX, 16
     MOV DX, AX
     MOV AX, [TERM_X]
     MOVZX EAX, AX
     SHL EAX, 1
     ADD EDX, EAX
     MOV ESI, EDX

     ADD ESI, 0B8000H

     MOV AH, 009H
     MOV AL, 219             ; CURSORCHAR!
     MOV [GS:ESI], AL
     MOV [GS:ESI+1], AH
     MOV [TERM_CURSORADDR], ESI
  CALL CHECK4MAC
RET


;
; Print the character in AL if the terminals are initialized
;
TERM_CURSORADDR  DD 0
NEWOUTCHAR       DB 0

NEWOUTPUTCHAR:
   CMP AL, 10
   JE near NEWOUTCHAR_SKIPCHAR                ; OTHERWISE MY CURSOR DISAPEARS

   PUSH EDI
   PUSH AX
     CMP byte [TERM_ACTIVE], 0
     JE DONTHIDECURSOR
       MOV EDI, [TERM_CURSORADDR]

       XOR AX, AX
       CMP dword [CURRENTTERMINAL], 0
       JE NOTGREENCURSORHIDE
         MOV AX, 00AB00H
       NOTGREENCURSORHIDE:
       MOV [GS:EDI], AX
     DONTHIDECURSOR:
   POP AX
   POP EDI
   MOV [NEWOUTCHAR], AL
   CMP AL, 13
   JE near NEWOUTCHAR_CR
   CMP AL, 8
   JE near NEWOUTCHAR_BS

   MOV AL, GREENCOLOR

   
   CMP dword [CURRENTTERMINAL], 0
   JNE NOTCOLORED
     MOV AL, [TEXTATTRIB]
  NOTCOLORED:
   MOV [TERM_ATTR], AL
   MOV AX, [TERM_Y]
   MOV DX, 160
   MUL DX
   SHL EDX, 16
   MOV DX, AX

   MOV AX, [TERM_X]
   MOVZX EAX, AX
   SHL EAX, 1

   ADD EDX, EAX
   MOV [TERM_BASE], EDX
   ADD EDX, [TERM_MEMADDR]
   MOV ESI, EDX

   MOV AL, [NEWOUTCHAR]
   MOV AH, [TERM_ATTR]
   MOV [GS:ESI+1], AH
   MOV [GS:ESI], AL

   MOV AL, [TERM_ACTIVE]
   CMP AL, 0
   JE near DONTOUTPUTMONITOR
     MOV AX, [TERM_Y]
     ADD AX, 44
     SUB AX, [TERM_LINES]

     MOV DX, 160
     MUL DX
     SHL EDX, 16
     MOV DX, AX
     MOV AX, [TERM_X]
     MOVZX EAX, AX
     SHL EAX, 1
     ADD EDX, EAX
     MOV ESI, EDX

     ADD ESI, 0B8000H

     MOV AL, [NEWOUTCHAR]
     MOV AH, [TERM_ATTR]
     MOV [GS:ESI+1], AH
     MOV [GS:ESI], AL
     INC ESI
     INC ESI
     MOV AH, 009H
     MOV AL, 219             ; CURSORCHAR!
     MOV [GS:ESI], AL
     MOV [GS:ESI+1], AH
     MOV [TERM_CURSORADDR], ESI

     MOV BL, USEBOCHS        ; BOCHS Emulator?
     CMP BL, 0
     JE NEAR SKIPBOCHSCHAR
     ADD ESI, (50-5-9)*160
     MOV [GS:ESI], AL
     MOV [GS:ESI+1], AH
     MOV AL, [NEWOUTCHAR]
     MOV AH, [TERM_ATTR]
     MOV [GS:ESI-2], AL
     MOV [GS:ESI-1], AH
SKIPBOCHSCHAR:
 
  DONTOUTPUTMONITOR:
  MOV AX, [TERM_X]
  INC AX
  MOV [TERM_X], AX

NEWOUTCHAR_SKIPCHAR:
RET

;
OUTPUTCHAR:
   CMP byte [NEWTERMINALON], 0
   JE OLDTERMINAL
   PUSHAD
     CALL NEWOUTPUTCHAR        ; Used to print text into a terminal
   POPAD
 RET

OLDTERMINAL:     ; Used to print boot-messages on startup using the BIOS
   PUSH BX
   PUSH CX
      CMP AL, 13
      JE SKIPATTRIB
      CMP AL, 10
      JE SKIPATTRIB
      PUSH AX
       MOV BL, [TEXTATTRIB]
       MOV AH, 09H
       MOV AL, ' '     ; A SPACE
       ;MOV BL, 02H
       MOV BH, 0
       MOV CX, 1
       MOV [REAL_EAX], EAX
       MOV [REAL_EBX], EBX
       MOV [REAL_ECX], ECX
       MOV AL, 3     ; SYSTEM16 FUNCTION
       MOV AH, 10H   ; INT 10H
       CLI
         INT 20H                      ; SET ATTRIBUTE
       STI
      POP AX
      SKIPATTRIB:
      PUSH AX
       MOV AH, 0EH
       MOV BX, 0
       MOV [REAL_EAX], EAX
       MOV [REAL_EBX], EBX
       MOV AL, 3
       MOV AH, 10H   ; INT 10H
       CLI
         INT 20H
       STI
      POP AX

    POP CX
    POP BX
RET


;
SETCURSORCOLOR:
     PUSHA
      CMP byte [CURSORFLASH], 0
      JE ENDOFCURSORCOLOR
      CALL VRETRACE
      MOV AH, [GS:0600H+141]


      MOV    AL, 57
      CMP dword [CURRENTTERMINAL], 0
      JNE GREENTERMINALCURSORCOLOR

      MOV    dx,3c8h
      out    dx,al
      inc    dx

      XOR    AL, AL
      out    dx,al

      mov    al, AH
      SHL    AL, 1
      out    dx,al

      mov    al, AH
      SHL    AL, 2
      out    dx, al
      JMP ENDOFCURSORCOLOR
      GREENTERMINALCURSORCOLOR:
      MOV    dx,3c8h
      out    dx,al
      inc    dx

      XOR    AL, AL
      out    dx,al

      mov    al, AH
      SHL    AL, 2
      out    dx,al

      XOR    al, AL
      out    dx, al

      ENDOFCURSORCOLOR:
    POPA
RET


;
WRITECURADDR:

   MOV EDI, 0B8000H + 10
   MOV ESI, ESP
   MOV ECX, 20
   DUMPSTACK:
     MOV EAX, [SS:ESI]   ; CS
     PUSH EDI
     PUSH ECX
     MOV ECX, 8
;     CALL DISPWORD
     POP ECX
     POP EDI
     ADD EDI, (80*2)
     ADD ESI, 4
   LOOP DUMPSTACK

   MOV ECX, 4
   MOV EDI, 0B8000H + (80*2*55) + (2*60)
   MOV EAX, [SS:ESP+(4*12)]
   CALL DISPWORD

   MOV ECX, 8
   MOV EDI, 0B8000H + (80*2*55) + (2*(60+5))
   MOV EAX, [SS:ESP+(4*11)]
   CALL DISPWORD

RET


;
INIT_TOPBAR:
  MOV CX, 8*6
  DEC CX
  CALL SET_VGA_SPLIT
  MOV CX, 80 * 50
  CALL SET_VGA_START

  MOV EDI, 0B8000H
  ADD EDI, 80*50*2
  MOV ESI,  TOPBARMEM
  MOV AL, 08FH
  MOV AH, '.'
  MOV ECX, 80*5
  CLEARTOPBARLOOP:
    MOV AH, [DS:ESI]
    MOV [GS:EDI+1], AL
    MOV [GS:EDI], AH
    INC EDI
    INC EDI
    INC ESI
  LOOP CLEARTOPBARLOOP



  PUSH EDI
  MOV ECX, 80*5
  MOV AL, 0F7H
  CLEARINFBARLOOP:
    MOV AH, ' '
    MOV [GS:EDI+1], AL
    MOV [GS:EDI], AH
    INC EDI
    INC EDI
  LOOP CLEARINFBARLOOP
  POP EDI

  MOV AL, 0F0H
  MOV AH, 231
  MOV [GS:EDI], AH
  MOV [GS:EDI+1], AL

  ADD EDI, 79*2

  MOV AL, 000FH
  MOV AH, 232
  MOV [GS:EDI], AH
  MOV [GS:EDI+1], AL


  MOV EDI, 0B8000H
  ADD EDI, 80*50*2
  ADD EDI, 80*1*2
  ADD EDI, 4
  MOV DL, 198
  MOV DH, 08CH         ; 08FH
  MOV ECX, 3
  LOGOVERLOOP:
    PUSH ECX
      MOV ECX, 6
      LOGOHORLOOP:
        MOV [GS:EDI], DL
        MOV [GS:EDI+1], DH
        INC DL
        ADD EDI, 2
      LOOP LOGOHORLOOP
      ADD EDI, (80-6)*2
    POP ECX
  LOOP LOGOVERLOOP


RET
;
; IN EAX = TERMINALNR
;
SETTERMINAL_W:
  PUSH EAX
    MOV EAX, [CURRENTTERMINAL]
    CMP EAX, 0FFFFH
    JE DONTSTORECURRENTTERMINAL
       MOV ESI, EAX
       SHL ESI, 6
       ADD ESI,  TERMINALS
       MOV AX, [TERM_X]
       MOV [DS:ESI+20], AX
       MOV AX, [TERM_Y]
       MOV [DS:ESI+22], AX
       MOV AL, [TERM_ATTR]
       MOV [DS:ESI+8], AL
    DONTSTORECURRENTTERMINAL:
  POP EAX

  MOV [CURRENTTERMINAL], EAX
  MOV ESI, EAX
  SHL ESI, 6
  ADD ESI,  TERMINALS

  MOV AX, [DS:ESI+4]
  MOV [TERM_HOR], AX
  MOV AX, [DS:ESI+6]
  MOV [TERM_VER], AX
  MOV AX, [DS:ESI+20]
  MOV [TERM_X], AX
  MOV AX, [DS:ESI+22]
  MOV [TERM_Y], AX
  MOV AX, [DS:ESI+10]
  MOV [TERM_LINES], AX

  MOV AL, [DS:ESI+8]
  MOV [TERM_ATTR], AL
  MOV AL, [DS:ESI+9]
  MOV [TERM_ACTIVE], AL

  MOV EAX, [DS:ESI+12]
  MOV [TERM_MEMADDR], EAX
  MOV EAX, [DS:ESI+16]
  MOV [TERM_MEMSIZE], EAX
RET

;
ACTIVETERMINALS      DB 0
NEWTERM_NAMEPTR      DD 0
NEWTERM_COLOR        DB 0

MAKENEWTERMINAL:

    MOV [NEWTERM_COLOR], CL
    MOV [NEWTERM_NAMEPTR], EDI
    MOV AL, [ACTIVETERMINALS]
    MOVZX ESI, AL
    MOV EAX, ESI
    SHL ESI, 6
    ADD ESI,  TERMINALS

    MOV [DS:ESI], EAX             ; ID
    MOV AX, 80
    MOV [DS:ESI+4], AX            ; HOR
    MOV AX, 256
    MOV [DS:ESI+6], AX            ; VER

    MOV AX, 80
    MOV [DS:ESI+20], AX            ; X
    MOV AX, 256-1
    MOV [DS:ESI+22], AX            ; Y

    MOV AX, 256
    MOV [DS:ESI+10], AX           ; LINES

    MOV AL, 14
    MOV EBX, 80*256*2
    MOV [DS:ESI+16], EBX
    MOV DL, 0          ; DATA
    MOV DH, 1          ; 32Bit
    INT 20H

    MOV [DS:ESI+12], EDI
    PUSHAD
      MOV ECX, EBX
      SHR ECX, 1
      MOV AH, 0B2H
      MOV AL, [NEWTERM_COLOR]
      CLEARNEWTERMLOOP:
        MOV [GS:EDI+1], AL
        MOV [GS:EDI], AH
        INC EDI
        INC EDI
      LOOP CLEARNEWTERMLOOP
    POPAD

    PUSHAD
      ADD ESI, 32
      MOV EDI, [NEWTERM_NAMEPTR]
      MOV ECX, 16
      COPYNEWTERMNAMELOOP:
         MOV AL, [DS:EDI]
         MOV [DS:ESI], AL
         INC EDI
         INC ESI
      LOOP COPYNEWTERMNAMELOOP
    POPAD

    ADD ESI, 64
    MOV EAX, 0FFFFH
    MOV [DS:ESI], EAX            ; TERMINATE THE LAST ONE...

    MOV AL, [ACTIVETERMINALS]
    INC AL
    MOV [ACTIVETERMINALS], AL


RET
;
;LTH - warning msg fixed
;TERMINALS resb 64 * 10
TERMINALS times 64 * 10 db 0
;                      '0123456789ABCDEF'
TERM_TERMINAL       DB 'TERMINAL-SCREEN ',0
TERM_DEBUG          DB 'DEBUG-SCREEN    ',0
TERM_MOD            DB 'MODULE-SCREEN   ',0
TERM_BOOT           DB 'BOOTUP-SCREEN   ',0
TERM_CRASH          DB 'CRASH-SCREEN    ',0
DEBUGTERM_MSG       DB 13,10
                    DB 198,199,200,201,202,203,13,10
                    DB 204,205,206,207,208,209,13,10
                    DB 210,211,212,213,214,215,13,10
                    DB 'Debug Screen',13,10
                    DB '',13,10,0
BOOTTERM_MSG        DB 13,10,13,10,0
MODULETERM_MSG      DB 13,10
                    DB 198,199,200,201,202,203,13,10
                    DB 204,205,206,207,208,209,13,10
                    DB 210,211,212,213,214,215,13,10
                    DB 'Module Screen',13,10
                    DB '',13,10,0
CRASHTERM_MSG       DB 13,10
                    DB 198,199,200,201,202,203,13,10
                    DB 204,205,206,207,208,209,13,10
                    DB 210,211,212,213,214,215,13,10
                    DB 'Crash Screen',13,10
                    DB '',13,10,0


INITTERMINALS:
    MOV dword [CURRENTTERMINAL], 0FFFFH
    CALL INIT_TOPBAR


    MOV EDI,  TERM_TERMINAL ; 0
    MOV AX, 256
    MOV CL, 01H
    CALL MAKENEWTERMINAL

    MOV EDI,  TERM_DEBUG    ; 1
    MOV AX, 256
    MOV CL, 0A1H
    CALL MAKENEWTERMINAL

    MOV EDI,  TERM_BOOT     ; 2
    MOV AX, 256
    MOV CL, 0A1H
    CALL MAKENEWTERMINAL

    MOV EDI,  TERM_MOD      ; 3
    MOV AX, 256
    MOV CL, 0A1H
    CALL MAKENEWTERMINAL

    MOV EDI,  TERM_CRASH    ; 4
    MOV AX, 256
    MOV CL, 0A1H
    CALL MAKENEWTERMINAL

    MOV EAX, 2                    ; BOOT
    CALL SETTERMINAL_W


    MOV ECX, 80*50
    MOV EDI, 0B8000H
    MOV ESI, [TERM_MEMADDR]
    ADD ESI, (160 * (256-39))
    MOV AH, GREENCOLOR

    COPYBOOTINF:
      MOV AL, [GS:EDI]
      MOV [GS:ESI], AL
      MOV [GS:ESI+1], AH
      INC ESI
      INC EDI
      INC ESI
      INC EDI
    LOOP COPYBOOTINF

    XOR EAX, EAX
    CALL SETTERMINAL_W

    MOV AL, 1
    MOV [TERM_ACTIVE], AL
    MOV byte [NEWTERMINALON], 1
    XOR AX, AX
    MOV [TERM_SCROLLPOS], AX
    CALL SCROLL_TERM

    ;----------- [ INIT DEBUG TERMINAL ] ---------
    MOV EAX, 1
    CALL SETTERMINAL_W

    MOV AL, 4
    MOV EDI,  DEBUGTERM_MSG
    INT 20H

    ;----------- [ INIT MODULE TERMINAL ] ---------
    MOV EAX, 3
    CALL SETTERMINAL_W

    MOV AL, 4
    MOV EDI,  MODULETERM_MSG
    INT 20H

    ;----------- [ INIT CRASH TERMINAL ] ---------
    MOV EAX, 4
    CALL SETTERMINAL_W

    MOV AL, 4
    MOV EDI,  CRASHTERM_MSG
    INT 20H

    ;----------- [ INIT BOOT TERMINAL ] ---------
    MOV EAX, 2
    CALL SETTERMINAL_W

    MOV AL, 4
    MOV EDI,  BOOTTERM_MSG
    INT 20H

    ;--------------------------------------------
    MOV EAX, 0
    CALL SETTERMINAL_W
    MOV AL, 1
    MOV [TERM_ACTIVE], AL

   MOV ESI, [SWITCH_NEW]
   XOR ESI, ESI
   SHL ESI, 6
   ADD ESI,  TERMINALS
   ADD ESI, 32
   MOV EDI, 0B8000H
   ADD EDI, 50*(80*2)
   ADD EDI, 5*(80*2)
   ADD EDI, 4
   MOV AH, 0F0H
   MOV ECX, 16
   WRITE1STTERMNAMELOOP:
     MOV AL, [DS:ESI]
     MOV [GS:EDI+1], AH
     MOV [GS:EDI], AL
     INC ESI
     INC EDI
     INC EDI
   LOOP WRITE1STTERMNAMELOOP

RET

